javax.swing.plaf.metal

## Class MetalToolBarUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.ToolBarUI
    - - javax.swing.plaf.basic.BasicToolBarUI
      - - javax.swing.plaf.metal.MetalToolBarUI

- All Implemented Interfaces:
    SwingConstants

      public class MetalToolBarUI
      extends BasicToolBarUI

  A Metal Look and Feel implementation of ToolBarUI. This implementation is a "combined" view/controller.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `MetalToolBarUI.MetalContainerListener`
    `protected class` | `MetalToolBarUI.MetalDockingListener`
    `protected class` | `MetalToolBarUI.MetalRolloverListener`

    - ### Nested classes/interfaces inherited from class javax.swing.plaf.basic.BasicToolBarUI

      `BasicToolBarUI.DockingListener, BasicToolBarUI.DragWindow, BasicToolBarUI.FrameListener, BasicToolBarUI.PropertyListener, BasicToolBarUI.ToolBarContListener, BasicToolBarUI.ToolBarFocusListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected ContainerListener` | `contListener` This protected field is implementation specific.
    `protected PropertyChangeListener` | `rolloverListener` This protected field is implementation specific.

    - ### Fields inherited from class javax.swing.plaf.basic.BasicToolBarUI

      `constraintBeforeFloating, dockingBorderColor, dockingColor, dockingListener, downKey, dragWindow, floatingBorderColor, floatingColor, focusedCompIndex, leftKey, propertyListener, rightKey, toolBar, toolBarContListener, toolBarFocusListener, upKey`

    - ### Fields inherited from interface javax.swing.SwingConstants

      `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MetalToolBarUI()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected ContainerListener` | `createContainerListener()` Creates a container listener that will be added to the JToolBar.
    `protected MouseInputListener` | `createDockingListener()`
    `protected Border` | `createNonRolloverBorder()` Creates the non rollover border for toolbar components.
    `protected Border` | `createRolloverBorder()` Creates a rollover border for toolbar components.
    `protected PropertyChangeListener` | `createRolloverListener()` Creates a property change listener that will be added to the JToolBar.
    `static ComponentUI` | `createUI(JComponent c)`
    `protected void` | `installListeners()`
    `void` | `installUI(JComponent c)` Configures the specified component appropriately for the look and feel.
    `protected void` | `setBorderToNonRollover(Component c)` Sets the border of the component to have a non-rollover border which was created by the `BasicToolBarUI.createNonRolloverBorder()` method.
    `protected void` | `setDragOffset(Point p)`
    `protected void` | `uninstallListeners()`
    `void` | `uninstallUI(JComponent c)` Reverses configuration which was done on the specified component during `installUI`.
    `void` | `update(Graphics g, JComponent c)` If necessary paints the background of the component, then invokes `paint`.

    - ### Methods inherited from class javax.swing.plaf.basic.BasicToolBarUI

      `canDock, createDragWindow, createFloatingFrame, createFloatingWindow, createFrameListener, createPropertyListener, createToolBarContListener, createToolBarFocusListener, dragTo, floatAt, getDockingColor, getFloatingColor, getNonRolloverBorder, getRolloverBorder, installComponents, installDefaults, installKeyboardActions, installNonRolloverBorders, installNormalBorders, installRolloverBorders, isFloating, isRolloverBorders, navigateFocusedComp, paintDragWindow, setBorderToNormal, setBorderToRollover, setDockingColor, setFloating, setFloatingColor, setFloatingLocation, setOrientation, setRolloverBorders, uninstallComponents, uninstallDefaults, uninstallKeyboardActions`

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, paint`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### contListener

          protected ContainerListener contListener

      This protected field is implementation specific. Do not access directly or override. Use the create method instead.
      See Also:
        `createContainerListener()`

    - #### rolloverListener

          protected PropertyChangeListener rolloverListener

      This protected field is implementation specific. Do not access directly or override. Use the create method instead.
      See Also:
        `createRolloverListener()`

  - ### Constructor Detail

    - #### MetalToolBarUI

          public MetalToolBarUI()

  - ### Method Detail

    - #### createUI

          public static ComponentUI createUI(JComponent c)

    - #### installUI

          public void installUI(JComponent c)

      Description copied from class: `ComponentUI`
      Configures the specified component appropriately for the look and feel. This method is invoked when the `ComponentUI` instance is being installed as the UI delegate on the specified component. This method should completely configure the component for the look and feel, including the following:
      1. Install default property values for color, fonts, borders, icons, opacity, etc. on the component. Whenever possible, property values initialized by the client program should not be overridden.
      2. Install a `LayoutManager` on the component if necessary.
      3. Create/add any required sub-components to the component.
      4. Create/install event listeners on the component.
      5. Create/install a `PropertyChangeListener` on the component in order to detect and respond to component property changes appropriately.
      6. Install keyboard UI (mnemonics, traversal, etc.) on the component.
      7. Initialize any appropriate instance data.
      Overrides:
        `installUI` in class `BasicToolBarUI`
      Parameters:
        `c` - the component where this UI delegate is being installed
      See Also:
        `ComponentUI.uninstallUI(javax.swing.JComponent)`, `JComponent.setUI(javax.swing.plaf.ComponentUI)`, `JComponent.updateUI()`

    - #### uninstallUI

          public void uninstallUI(JComponent c)

      Description copied from class: `ComponentUI`
      Reverses configuration which was done on the specified component during `installUI`. This method is invoked when this `UIComponent` instance is being removed as the UI delegate for the specified component. This method should undo the configuration performed in `installUI`, being careful to leave the `JComponent` instance in a clean state (no extraneous listeners, look-and-feel-specific property objects, etc.). This should include the following:
      1. Remove any UI-set borders from the component.
      2. Remove any UI-set layout managers on the component.
      3. Remove any UI-added sub-components from the component.
      4. Remove any UI-added event/property listeners from the component.
      5. Remove any UI-installed keyboard UI from the component.
      6. Nullify any allocated instance data objects to allow for GC.
      Overrides:
        `uninstallUI` in class `BasicToolBarUI`
      Parameters:
        `c` - the component from which this UI delegate is being removed; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.installUI(javax.swing.JComponent)`, `JComponent.updateUI()`

    - #### installListeners

          protected void installListeners()

      Overrides:
        `installListeners` in class `BasicToolBarUI`

    - #### uninstallListeners

          protected void uninstallListeners()

      Overrides:
        `uninstallListeners` in class `BasicToolBarUI`

    - #### createRolloverBorder

          protected Border createRolloverBorder()

      Description copied from class: `BasicToolBarUI`
      Creates a rollover border for toolbar components. The rollover border will be installed if rollover borders are enabled.

      Override this method to provide an alternate rollover border.

      Overrides:
        `createRolloverBorder` in class `BasicToolBarUI`

    - #### createNonRolloverBorder

          protected Border createNonRolloverBorder()

      Description copied from class: `BasicToolBarUI`
      Creates the non rollover border for toolbar components. This border will be installed as the border for components added to the toolbar if rollover borders are not enabled.

      Override this method to provide an alternate rollover border.

      Overrides:
        `createNonRolloverBorder` in class `BasicToolBarUI`

    - #### setBorderToNonRollover

          protected void setBorderToNonRollover(Component c)

      Description copied from class: `BasicToolBarUI`
      Sets the border of the component to have a non-rollover border which was created by the `BasicToolBarUI.createNonRolloverBorder()` method.
      Overrides:
        `setBorderToNonRollover` in class `BasicToolBarUI`
      Parameters:
        `c` - component which will have a non-rollover border installed
      See Also:
        `BasicToolBarUI.createNonRolloverBorder()`

    - #### createContainerListener

          protected ContainerListener createContainerListener()

      Creates a container listener that will be added to the JToolBar. If this method returns null then it will not be added to the toolbar.
      Returns:
        an instance of a `ContainerListener` or null

    - #### createRolloverListener

          protected PropertyChangeListener createRolloverListener()

      Creates a property change listener that will be added to the JToolBar. If this method returns null then it will not be added to the toolbar.
      Returns:
        an instance of a `PropertyChangeListener` or null

    - #### createDockingListener

          protected MouseInputListener createDockingListener()

      Overrides:
        `createDockingListener` in class `BasicToolBarUI`

    - #### setDragOffset

          protected void setDragOffset(Point p)

    - #### update

          public void update(Graphics g,
                    JComponent c)

      If necessary paints the background of the component, then invokes `paint`.
      Overrides:
        `update` in class `ComponentUI`
      Parameters:
        `g` - Graphics to paint to
        `c` - JComponent painting on
      Throws:
        `NullPointerException` - if `g` or `c` is null
      Since:
        1.5
      See Also:
        `ComponentUI.update(java.awt.Graphics, javax.swing.JComponent)`, `ComponentUI.paint(java.awt.Graphics, javax.swing.JComponent)`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2019, Oracle and/or its affiliates. All rights reserved.